# frozen_string_literal: true

require 'forwardable'

module UU
  module LogContext
    attr_writer :context

    def context
      @context ||= {}
    end

    def append_context(context_)
      self.context = context.merge(context_)
    end

    def with(context_)
      original_context = context
      self.context = context.merge(context_)
      yield
    ensure
      self.context = original_context
    end
  end
end
