# frozen_string_literal: true

require 'forwardable'

module UU
  module Loggable
    def self.included(mod)
      mod.extend self
    end

    extend Forwardable

    def_delegators \
      :'::UU::Log.instance', \
      :debug, :info, :warn, :error, :fatal, :with

    def_delegators :'::UU::LoggerFluent::Formatter', :tag, :tag=
  end
end
